package ejb30.persistence.datatypes.client;

import javax.annotation.Resource;
import javax.ejb.*;
import javax.persistence.*;
import java.util.*;

public class DataTypesBizMethods
{
   public int create(EntityManager manager, int id, Boolean booleanData, Byte byteData, Character characterData, Short shortData, Integer integerData, Long longData, Float floatData, java.util.Date utilDateData, java.sql.Date sqlDateData, java.sql.Timestamp timeStampData)
   {
      DataTypes firstrow = new DataTypes(id, booleanData, byteData, characterData, shortData, integerData, longData, floatData, utilDateData, sqlDateData, timeStampData);
      manager.getTransaction().begin();
      manager.persist(firstrow);
      manager.getTransaction().commit();
      return firstrow.getId();
   }

   public DataTypes find(EntityManager manager, int id)
   {
      return manager.find(DataTypes.class, id);
   }

   public void remove(EntityManager manager, DataTypes del)
   {
      DataTypes toDelete = manager.merge(del);
      manager.remove(toDelete);
   }

   public Double getAvgofShort(EntityManager manager)
   {
      return (Double) manager.createQuery("SELECT avg(d.shortData) from DataTypes d ").getSingleResult();
   }
   
   public Double getAvgofByte(EntityManager manager)
   {
      return (Double) manager.createQuery("SELECT avg(d.byteData) from DataTypes d ").getSingleResult();
   }

   public Double getAvgofLong(EntityManager manager)
   {
      return (Double) manager.createQuery("SELECT avg(d.longData) from DataTypes d ").getSingleResult();
   }

   public Double getAvgofFloat(EntityManager manager)
   {
      return (Double) manager.createQuery("SELECT avg(d.floatData) from DataTypes d ").getSingleResult();
   }

   public Double getAvgofInteger(EntityManager manager)
   {
      return (Double) manager.createQuery("SELECT avg(d.integerData) from DataTypes d ").getSingleResult();
   }

   public List whereWithLong(EntityManager manager, long l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.longData = :long").setParameter("long",l).getResultList();

   }   

   public List whereWithShort(EntityManager manager, short l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.shortData = :short").setParameter("short",l).getResultList();
   }   

   public List whereWithInteger(EntityManager manager, Integer l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.integerData = :Integer").setParameter("Integer",l).getResultList();
   }   

   public List whereWithCharacter(EntityManager manager, Character l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.characterData = :Character").setParameter("Character",l).getResultList();
   }   

   public List whereWithByte(EntityManager manager, Byte l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.byteData = :Byte").setParameter("Byte",l).getResultList();
   }   

   public List whereWithFloat(EntityManager manager, Float l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.floatData = :Float").setParameter("Float",l).getResultList();
   }   

   public List utilDateSelection(EntityManager manager, java.util.Date l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.utilDateData = :utilDateParam").setParameter("utilDateParam",l).getResultList();
   }

   public List sqlDateSelection(EntityManager manager, java.sql.Date l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.sqlDateData = :sqlDateParam").setParameter("sqlDateParam",l).getResultList();
   }

   public List timeStampSelection(EntityManager manager, java.sql.Timestamp l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.timeStampData = :timeStampParam").setParameter("timeStampParam",l).getResultList();
      //return manager.createQuery("SELECT d from DataTypes d WHERE d.id = 1").getResultList();
   }

   public List maxRowSelection(EntityManager manager, Integer l)
   {
      return manager.createQuery("SELECT d from DataTypes d WHERE d.id = :idn").setParameter("idn",l).getResultList();
   }

   public void merge(EntityManager manager, DataTypes d)
   {
      manager.merge(d);
   }
   
}
